diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 2cfc6e101..fedbd41da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -316,67 +340,64 @@ public final class RenderBlocks
         } else {
             if (ao) {
                 {
-                    float dirB = cache.getBrightness(dirX, dirY, dirZ);
-                    boolean lefT = cache.getOpacity(dirX + lefX, dirY + lefY, dirZ + lefZ);
-                    boolean botT = cache.getOpacity(dirX - topX, dirY - topY, dirZ - topZ);
-                    boolean topT = cache.getOpacity(dirX + topX, dirY + topY, dirZ + topZ);
-                    boolean rigT = cache.getOpacity(dirX - lefX, dirY - lefY, dirZ - lefZ);
-                    float lB = cache.getBrightness(dirX + lefX, dirY + lefY, dirZ + lefZ);
-                    float bB = cache.getBrightness(dirX - topX, dirY - topY, dirZ - topZ);
-                    float tB = cache.getBrightness(dirX + topX, dirY + topY, dirZ + topZ);
-                    float rB = cache.getBrightness(dirX - lefX, dirY - lefY, dirZ - lefZ);
-                    float blB = botT && lefT ? lB : cache.getBrightness(dirX + lefX - topX, dirY + lefY - topY, dirZ + lefZ - topZ);
-                    float tlB = topT && lefT ? lB : cache.getBrightness(dirX + lefX + topX, dirY + lefY + topY, dirZ + lefZ + topZ);
-                    float brB = botT && rigT ? rB : cache.getBrightness(dirX - lefX - topX, dirY - lefY - topY, dirZ - lefZ - topZ);
-                    float trB = topT && rigT ? rB : cache.getBrightness(dirX - lefX + topX, dirY - lefY + topY, dirZ - lefZ + topZ);
+                    float dirB = this.cache.getBrightness(dirX, dirY, dirZ);
+                    boolean lefT = this.cache.getOpacity(dirX + lefX, dirY + lefY, dirZ + lefZ);
+                    boolean botT = this.cache.getOpacity(dirX - topX, dirY - topY, dirZ - topZ);
+                    boolean topT = this.cache.getOpacity(dirX + topX, dirY + topY, dirZ + topZ);
+                    boolean rigT = this.cache.getOpacity(dirX - lefX, dirY - lefY, dirZ - lefZ);
+                    float lB = this.cache.getBrightness(dirX + lefX, dirY + lefY, dirZ + lefZ);
+                    float bB = this.cache.getBrightness(dirX - topX, dirY - topY, dirZ - topZ);
+                    float tB = this.cache.getBrightness(dirX + topX, dirY + topY, dirZ + topZ);
+                    float rB = this.cache.getBrightness(dirX - lefX, dirY - lefY, dirZ - lefZ);
+                    float blB = botT && lefT ? lB : this.cache.getBrightness(dirX + lefX - topX, dirY + lefY - topY, dirZ + lefZ - topZ);
+                    float tlB = topT && lefT ? lB : this.cache.getBrightness(dirX + lefX + topX, dirY + lefY + topY, dirZ + lefZ + topZ);
+                    float brB = botT && rigT ? rB : this.cache.getBrightness(dirX - lefX - topX, dirY - lefY - topY, dirZ - lefZ - topZ);
+                    float trB = topT && rigT ? rB : this.cache.getBrightness(dirX - lefX + topX, dirY - lefY + topY, dirZ - lefZ + topZ);
                     lightTL = (tlB + lB + tB + dirB) / 4.0F;
                     lightTR = (tB + dirB + trB + rB) / 4.0F;
                     lightBR = (dirB + bB + rB + brB) / 4.0F;
                     lightBL = (lB + blB + dirB + bB) / 4.0F;
                 }
-                if(!isFullCube){
-                    float dirB = cache.getBrightness(0, 0, 0);
-                    boolean lefT = cache.getOpacity(lefX, lefY, lefZ);
-                    boolean botT = cache.getOpacity(-topX, -topY, -topZ);
-                    boolean topT = cache.getOpacity(topX, topY, topZ);
-                    boolean rigT = cache.getOpacity(-lefX, -lefY, -lefZ);
-                    float lB = cache.getBrightness(lefX, lefY, lefZ);
-                    float bB = cache.getBrightness(-topX, -topY, -topZ);
-                    float tB = cache.getBrightness(topX, topY, topZ);
-                    float rB = cache.getBrightness(-lefX, -lefY, -lefZ);
-                    float blB = botT && lefT ? lB : cache.getBrightness(lefX - topX, lefY - topY, lefZ - topZ);
-                    float tlB = topT && lefT ? lB : cache.getBrightness(lefX + topX, lefY + topY, lefZ + topZ);
-                    float brB = botT && rigT ? rB : cache.getBrightness(-lefX - topX, -lefY - topY, -lefZ - topZ);
-                    float trB = topT && rigT ? rB : cache.getBrightness(-lefX + topX, -lefY + topY, -lefZ + topZ);
-                    lightTL = (tlB + lB + tB + dirB) / 4.0F * depth + lightTL*(1-depth);
-                    lightTR = (tB + dirB + trB + rB) / 4.0F * depth + lightTR*(1-depth);
-                    lightBR = (dirB + bB + rB + brB) / 4.0F * depth + lightBR*(1-depth);
-                    lightBL = (lB + blB + dirB + bB) / 4.0F * depth + lightBL*(1-depth);
+                if (!isFullCube) {
+                    float dirB = this.cache.getBrightness(0, 0, 0);
+                    boolean lefT = this.cache.getOpacity(lefX, lefY, lefZ);
+                    boolean botT = this.cache.getOpacity(-topX, -topY, -topZ);
+                    boolean topT = this.cache.getOpacity(topX, topY, topZ);
+                    boolean rigT = this.cache.getOpacity(-lefX, -lefY, -lefZ);
+                    float lB = this.cache.getBrightness(lefX, lefY, lefZ);
+                    float bB = this.cache.getBrightness(-topX, -topY, -topZ);
+                    float tB = this.cache.getBrightness(topX, topY, topZ);
+                    float rB = this.cache.getBrightness(-lefX, -lefY, -lefZ);
+                    float blB = botT && lefT ? lB : this.cache.getBrightness(lefX - topX, lefY - topY, lefZ - topZ);
+                    float tlB = topT && lefT ? lB : this.cache.getBrightness(lefX + topX, lefY + topY, lefZ + topZ);
+                    float brB = botT && rigT ? rB : this.cache.getBrightness(-lefX - topX, -lefY - topY, -lefZ - topZ);
+                    float trB = topT && rigT ? rB : this.cache.getBrightness(-lefX + topX, -lefY + topY, -lefZ + topZ);
+                    lightTL = (tlB + lB + tB + dirB) / 4.0F * depth + lightTL * (1 - depth);
+                    lightTR = (tB + dirB + trB + rB) / 4.0F * depth + lightTR * (1 - depth);
+                    lightBR = (dirB + bB + rB + brB) / 4.0F * depth + lightBR * (1 - depth);
+                    lightBL = (lB + blB + dirB + bB) / 4.0F * depth + lightBL * (1 - depth);
                 }
             } else {
                 int dirX2 = dirX;
                 int dirY2 = dirY;
                 int dirZ2 = dirZ;
 
-                if(!isFullCube) {
+                if (!isFullCube) {
                     dirX2 = 0;
                     dirY2 = 0;
                     dirZ2 = 0;
                 }
 
-                float brightness = cache.getBrightness(dirX2, dirY2, dirZ2);
+                float brightness = this.cache.getBrightness(dirX2, dirY2, dirZ2);
                 lightTL = lightBL = lightBR = lightTR = brightness;
             }
         }
 
-        if (overbright || !BlockModel.ENABLE_DIRECTIONAL_LIGHTING)
-        {
+        if (this.overbright || !BlockModel.ENABLE_DIRECTIONAL_LIGHTING) {
             this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
             this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
             this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b;
-        }
-        else
-        {
+        } else {
             this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r * SIDE_LIGHT_MULTIPLIER[side.getId()];
             this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g * SIDE_LIGHT_MULTIPLIER[side.getId()];
             this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b * SIDE_LIGHT_MULTIPLIER[side.getId()];
@@ -406,21 +427,22 @@ public final class RenderBlocks
         this.colorBlueTopRight *= ltr;
     }
 
-    public void renderBottomFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
-    {
-        if(overrideBlockTexture != null) tex = overrideBlockTexture;
+    public void renderBottomFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+        renderBottomFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
+    }
+
+    public void renderBottomFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+        if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(bounds.minX);
-        double d4 = tex.getSubIconU(bounds.maxX);
-        double d5 = tex.getSubIconV(bounds.minZ);
-        double d6 = tex.getSubIconV(bounds.maxZ);
-        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
-        {
+        double d3 = tex.getSubIconU(bounds.minX());
+        double d4 = tex.getSubIconU(bounds.maxX());
+        double d5 = tex.getSubIconV(bounds.minZ());
+        double d6 = tex.getSubIconV(bounds.maxZ());
+        if (bounds.minX() < 0.0D || bounds.maxX() > 1.0D) {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
-        {
+        if (bounds.minZ() < 0.0D || bounds.maxZ() > 1.0D) {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
         }
@@ -428,64 +450,57 @@ public final class RenderBlocks
         double d8 = d3;
         double d9 = d5;
         double d10 = d6;
-        if(uvRotateBottom == 2)
-        {
-            d3 = tex.getSubIconU(bounds.minZ);
-            d5 = tex.getSubIconV(1 - bounds.maxX);
-            d4 = tex.getSubIconU(bounds.maxZ);
-            d6 = tex.getSubIconV(1 - bounds.minX);
+        if (this.uvRotateBottom == 2) {
+            d3 = tex.getSubIconU(bounds.minZ());
+            d5 = tex.getSubIconV(1 - bounds.maxX());
+            d4 = tex.getSubIconU(bounds.maxZ());
+            d6 = tex.getSubIconV(1 - bounds.minX());
             d9 = d5;
             d10 = d6;
             d7 = d3;
             d8 = d4;
             d5 = d6;
             d6 = d9;
-        } else
-        if(uvRotateBottom == 1)
-        {
-            d3 = tex.getSubIconU(1 - bounds.maxZ);
-            d5 = tex.getSubIconV(bounds.minX);
-            d4 = tex.getSubIconU(1 - bounds.minZ);
-            d6 = tex.getSubIconV(bounds.maxX);
+        } else if (this.uvRotateBottom == 1) {
+            d3 = tex.getSubIconU(1 - bounds.maxZ());
+            d5 = tex.getSubIconV(bounds.minX());
+            d4 = tex.getSubIconU(1 - bounds.minZ());
+            d6 = tex.getSubIconV(bounds.maxX());
             d7 = d4;
             d8 = d3;
             d3 = d7;
             d4 = d8;
             d9 = d6;
             d10 = d5;
-        } else
-        if(uvRotateBottom == 3)
-        {
-            d3 = tex.getSubIconU(1 - bounds.minX);
-            d4 = tex.getSubIconU(1 - bounds.maxX);
-            d5 = tex.getSubIconV(1 - bounds.minZ);
-            d6 = tex.getSubIconV(1 - bounds.maxZ);
+        } else if (this.uvRotateBottom == 3) {
+            d3 = tex.getSubIconU(1 - bounds.minX());
+            d4 = tex.getSubIconU(1 - bounds.maxX());
+            d5 = tex.getSubIconV(1 - bounds.minZ());
+            d6 = tex.getSubIconV(1 - bounds.maxZ());
             d7 = d4;
             d8 = d3;
             d9 = d5;
             d10 = d6;
         }
-        double d11 = x + bounds.minX;
-        double d12 = x + bounds.maxX;
-        double d13 = y + bounds.minY;
-        double d14 = z + bounds.minZ;
-        double d15 = z + bounds.maxZ;
-        if(enableAO)
-        {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
+        double d11 = x + bounds.minX();
+        double d12 = x + bounds.maxX();
+        double d13 = y + bounds.minY();
+        double d14 = z + bounds.minZ();
+        double d15 = z + bounds.maxZ();
+        if (this.enableAO) {
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
-        } else
-        {
+        } else {
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
@@ -493,21 +508,22 @@ public final class RenderBlocks
         }
     }
 
-    public void renderTopFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
-    {
-        if(overrideBlockTexture != null) tex = overrideBlockTexture;
+    public void renderTopFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+        renderTopFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
+    }
+
+    public void renderTopFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+        if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(bounds.minX);
-        double d4 = tex.getSubIconU(bounds.maxX);
-        double d5 = tex.getSubIconV(bounds.minZ);
-        double d6 = tex.getSubIconV(bounds.maxZ);
-        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
-        {
+        double d3 = tex.getSubIconU(bounds.minX());
+        double d4 = tex.getSubIconU(bounds.maxX());
+        double d5 = tex.getSubIconV(bounds.minZ());
+        double d6 = tex.getSubIconV(bounds.maxZ());
+        if (bounds.minX() < 0.0D || bounds.maxX() > 1.0D) {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
-        {
+        if (bounds.minZ() < 0.0D || bounds.maxZ() > 1.0D) {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
         }
@@ -515,64 +531,57 @@ public final class RenderBlocks
         double d8 = d3;
         double d9 = d5;
         double d10 = d6;
-        if(uvRotateTop == 1)
-        {
-            d3 = tex.getSubIconU(bounds.minZ);
-            d5 = tex.getSubIconV(1 - bounds.maxX);
-            d4 = tex.getSubIconU(bounds.maxZ);
-            d6 = tex.getSubIconV(1 - bounds.minX);
+        if (this.uvRotateTop == 1) {
+            d3 = tex.getSubIconU(bounds.minZ());
+            d5 = tex.getSubIconV(1 - bounds.maxX());
+            d4 = tex.getSubIconU(bounds.maxZ());
+            d6 = tex.getSubIconV(1 - bounds.minX());
             d9 = d5;
             d10 = d6;
             d7 = d3;
             d8 = d4;
             d5 = d6;
             d6 = d9;
-        } else
-        if(uvRotateTop == 2)
-        {
-            d3 = tex.getSubIconU(1 - bounds.maxZ);
-            d5 = tex.getSubIconV(bounds.minX);
-            d4 = tex.getSubIconU(1 - bounds.minZ);
-            d6 = tex.getSubIconV(bounds.maxX);
+        } else if (this.uvRotateTop == 2) {
+            d3 = tex.getSubIconU(1 - bounds.maxZ());
+            d5 = tex.getSubIconV(bounds.minX());
+            d4 = tex.getSubIconU(1 - bounds.minZ());
+            d6 = tex.getSubIconV(bounds.maxX());
             d7 = d4;
             d8 = d3;
             d3 = d7;
             d4 = d8;
             d9 = d6;
             d10 = d5;
-        } else
-        if(uvRotateTop == 3)
-        {
-            d3 = tex.getSubIconU(1 - bounds.minX);
-            d4 = tex.getSubIconU(1 - bounds.maxX);
-            d5 = tex.getSubIconV(1 - bounds.minZ);
-            d6 = tex.getSubIconV(1 - bounds.maxZ);
+        } else if (this.uvRotateTop == 3) {
+            d3 = tex.getSubIconU(1 - bounds.minX());
+            d4 = tex.getSubIconU(1 - bounds.maxX());
+            d5 = tex.getSubIconV(1 - bounds.minZ());
+            d6 = tex.getSubIconV(1 - bounds.maxZ());
             d7 = d4;
             d8 = d3;
             d9 = d5;
             d10 = d6;
         }
-        double d11 = x + bounds.minX;
-        double d12 = x + bounds.maxX;
-        double d13 = y + bounds.maxY;
-        double d14 = z + bounds.minZ;
-        double d15 = z + bounds.maxZ;
-        if(enableAO)
-        {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
+        double d11 = x + bounds.minX();
+        double d12 = x + bounds.maxX();
+        double d13 = y + bounds.maxY();
+        double d14 = z + bounds.minZ();
+        double d15 = z + bounds.maxZ();
+        if (this.enableAO) {
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
-        } else
-        {
+        } else {
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
@@ -580,27 +589,27 @@ public final class RenderBlocks
         }
     }
 
-    public void renderNorthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
-    {
-        if(overrideBlockTexture != null) tex = overrideBlockTexture;
+    public void renderNorthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+        renderNorthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
+    }
+
+    public void renderNorthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+        if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(bounds.minX);
-        double d4 = tex.getSubIconU(bounds.maxX);
-        double d5 = tex.getSubIconV(1 - bounds.maxY);
-        double d6 = tex.getSubIconV(1 - bounds.minY);
-        if(flipTexture)
-        {
+        double d3 = tex.getSubIconU(bounds.minX());
+        double d4 = tex.getSubIconU(bounds.maxX());
+        double d5 = tex.getSubIconV(1 - bounds.maxY());
+        double d6 = tex.getSubIconV(1 - bounds.minY());
+        if (this.flipTexture) {
             double d7 = d3;
             d3 = d4;
             d4 = d7;
         }
-        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
-        {
+        if (bounds.minX() < 0.0D || bounds.maxX() > 1.0D) {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
-        {
+        if (bounds.minY() < 0.0D || bounds.maxY() > 1.0D) {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
         }
@@ -608,64 +617,57 @@ public final class RenderBlocks
         double d9 = d3;
         double d10 = d5;
         double d11 = d6;
-        if(uvRotateEast == 2)
-        {
-            d3 = tex.getSubIconU(bounds.minY);
-            d5 = tex.getSubIconV(1 - bounds.minX);
-            d4 = tex.getSubIconU(bounds.maxY);
-            d6 = tex.getSubIconV(1 - bounds.maxX);
+        if (this.uvRotateEast == 2) {
+            d3 = tex.getSubIconU(bounds.minY());
+            d5 = tex.getSubIconV(1 - bounds.minX());
+            d4 = tex.getSubIconU(bounds.maxY());
+            d6 = tex.getSubIconV(1 - bounds.maxX());
             d10 = d5;
             d11 = d6;
             d8 = d3;
             d9 = d4;
             d5 = d6;
             d6 = d10;
-        } else
-        if(uvRotateEast == 1)
-        {
-            d3 = tex.getSubIconU(1 - bounds.maxY);
-            d5 = tex.getSubIconV(bounds.maxX);
-            d4 = tex.getSubIconU(1 - bounds.minY);
-            d6 = tex.getSubIconV(bounds.minX);
+        } else if (this.uvRotateEast == 1) {
+            d3 = tex.getSubIconU(1 - bounds.maxY());
+            d5 = tex.getSubIconV(bounds.maxX());
+            d4 = tex.getSubIconU(1 - bounds.minY());
+            d6 = tex.getSubIconV(bounds.minX());
             d8 = d4;
             d9 = d3;
             d3 = d8;
             d4 = d9;
             d10 = d6;
             d11 = d5;
-        } else
-        if(uvRotateEast == 3)
-        {
-            d3 = tex.getSubIconU(1 - bounds.minX);
-            d4 = tex.getSubIconU(1 - bounds.maxX);
-            d5 = tex.getSubIconV(bounds.maxY);
-            d6 = tex.getSubIconV(bounds.minY);
+        } else if (this.uvRotateEast == 3) {
+            d3 = tex.getSubIconU(1 - bounds.minX());
+            d4 = tex.getSubIconU(1 - bounds.maxX());
+            d5 = tex.getSubIconV(bounds.maxY());
+            d6 = tex.getSubIconV(bounds.minY());
             d8 = d4;
             d9 = d3;
             d10 = d5;
             d11 = d6;
         }
-        double d12 = x + bounds.minX;
-        double d13 = x + bounds.maxX;
-        double d14 = y + bounds.minY;
-        double d15 = y + bounds.maxY;
-        double d16 = z + bounds.minZ;
-        if(enableAO)
-        {
-        	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
+        double d12 = x + bounds.minX();
+        double d13 = x + bounds.maxX();
+        double d14 = y + bounds.minY();
+        double d15 = y + bounds.maxY();
+        double d16 = z + bounds.minZ();
+        if (this.enableAO) {
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
-            if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
+            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
-        } else
-        {
+        } else {
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
@@ -673,27 +675,27 @@ public final class RenderBlocks
         }
     }
 
-    public void renderSouthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
-    {
-        if(overrideBlockTexture != null) tex = overrideBlockTexture;
+    public void renderSouthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+        renderSouthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
+    }
+
+    public void renderSouthFace(@NotNull Tessellator tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+        if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(bounds.minX);
-        double d4 = tex.getSubIconU(bounds.maxX);
-        double d5 = tex.getSubIconV(1 - bounds.maxY);
-        double d6 = tex.getSubIconV(1 - bounds.minY);
-        if(flipTexture)
-        {
+        double d3 = tex.getSubIconU(bounds.minX());
+        double d4 = tex.getSubIconU(bounds.maxX());
+        double d5 = tex.getSubIconV(1 - bounds.maxY());
+        double d6 = tex.getSubIconV(1 - bounds.minY());
+        if (this.flipTexture) {
             double d7 = d3;
             d3 = d4;
             d4 = d7;
         }
-        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
-        {
+        if (bounds.minX() < 0.0D || bounds.maxX() > 1.0D) {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
-        {
+        if (bounds.minY() < 0.0D || bounds.maxY() > 1.0D) {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
         }
